<?php
if(isset($_POST['del']) and isset($_POST['eventdel'])) {
    foreach($_POST['eventdel'] as $eventkey) {
        $error = deletEvent($db,$lang,$eventkey);
    }
}

if(isset($_POST['save']) and key($_POST['save']) != "add")
    $error = editEvent($db,$lang,$cal_daten); # ,$event_schema

if(isset($_POST['save']) and key($_POST['save']) == "add")
    $error = addEvent($db,$lang,$cal_daten); # ,$event_schema

# das feld mit dem key ermiteln
function eventSchema($db,$cal_daten) {
    $event_schema = $db->schema();
    unset($event_schema[$cal_daten['key_feld']]);
    return $event_schema;
}

function emptyEvent($db,$cal_daten) {
    $event_schema = eventSchema($db,$cal_daten);
    $getday = getdate();
    foreach($event_schema as $inhalt) {
        if($inhalt[0] == $cal_daten['event_day'])
            $record[$inhalt[0]] = $getday['mday'];
        elseif($inhalt[0] == $cal_daten['event_month'])
            $record[$inhalt[0]] = $getday['mon'];
        elseif($inhalt[0] == $cal_daten['event_year'])
            $record[$inhalt[0]] = $getday['year'];
        else
            $record[$inhalt[0]] = "";
    }
    return $record;
}
# denn höchsten key ermiteln und mit + 1 als neuen key zurückgeben
function getNextKey($db,$event_schema,$cal_daten) {
    $maxkey = 0;
    if($schema_key = $cal_daten['key_feld']) {
        $result = $db->getall();
        if(is_array($result) and count($result) == 0)
            return array($maxkey + 1,$schema_key);
        elseif(!is_array($result))
            return false;
        $key = array();
        foreach($result as $item) {
            $key[] = $item[$schema_key];
        }
        natcasesort($key);
        $maxkey = $key[count($key) - 1] + 1;
        # nur mal so zur sicherheit
        while(in_array($maxkey,$key)) {
            $maxkey++;
        }
        # zurück mit nextkey und dem feldnamen dafür
        return array($maxkey,$schema_key);
    }
    return false;
}

function CheckInput($lang,$event_schema,$cal_daten) {
    $typen = array("0" => "int","1" => "string","2" => "array","3" => "float","4" => "bool");
    $input = array();
    $error = false;
    $key_feld_tmp = 1;
    if(isset($_POST['save'])) {
        $input[$cal_daten['key_feld']] = key($_POST['save']);
        $key_feld_tmp = 0;
    }
    foreach($event_schema as $schema) {
        $post = false;
        if(isset($_POST[$schema[0]]))
            $post = getRequestParam($schema[0],false);
        if(isset($schema[0]) and isset($schema[1]) and $post) {
            $testen = getRequestParam($schema[0],false);
            if($schema[1] != "4")
                settype($testen,$typen[$schema[1]]);
            else {
                # beim type bool wird erstmal alles aus false gesetzt
                $testen = false;
                # und nur wenn da true drin ist wird true gesetzt
                if(strtolower(getRequestParam($schema[0],false)) == "true")
                    $testen = true;
            }
            if(strlen(getRequestParam($schema[0],false)) == strlen($testen) or $schema[1] == "4") {
                if($schema[1] == "0" and is_int($testen)) {
                    $input[$schema[0]] = $testen;
                } elseif($schema[1] == "1" and is_string($testen)) {
                    $input[$schema[0]] = $testen;
                } elseif($schema[1] == "3" and is_float($testen)) {
                    $input[$schema[0]] = $testen;
                } elseif($schema[1] == "4" and is_bool($testen)) {
                    $input[$schema[0]] = $testen;
                }
                if(!isset($input[$schema[0]])) {
                    $error['error'] = $lang['lang']['error_input'];
                    $input = false;
                }
            } else {
                $error['error'] = $lang['lang']['error_input'];
                $input = false;
            }
        }
    }
    if(count($event_schema) - $key_feld_tmp != count($input)) {
        $error['error'] = $lang['lang']['error_input_empty'];
        $input = false;
    }
    return array($input,$error);
}

function addEvent($db,$lang,$cal_daten) { # ,$event_schema
    $event_schema = eventSchema($db,$cal_daten);
    if($nextkey = getNextKey($db,$event_schema,$cal_daten)) {
        list($record,$error) = CheckInput($lang,$event_schema,$cal_daten);
        if($record and $error === false) {
            # das feld für denn key mit nextkey belegen
            $record[$nextkey[1]] = $nextkey[0];
            // Add a _new_ entry
            if (!$db->add($record)) {
                $messages[]['error'] = $lang['lang']['error_add'];
                return $messages;
            } else {
                $messages[]['succes'] = $lang['lang']['succes_add'];
                return $messages;
            }
        } else {
            $messages[] = $error;
            return $messages;
        }
    } else {
        $messages[]['error'] = $lang['lang']['error_NextKey'];
        return $messages;
    }
}

function editEvent($db,$lang,$cal_daten) {# ,$event_schema
    $event_schema = eventSchema($db,$cal_daten);
    list($record,$error) = CheckInput($lang,$event_schema,$cal_daten);
    if($record and $error === false) {
        if($db->exists($record[$cal_daten['key_feld']])) {
            // Add a _new_ entry
            if (!$db->edit($record)) {
                $messages[]['error'] = $lang['lang']['error_edit'];
                return $messages;
            } else {
                $messages[]['succes'] = $lang['lang']['succes_edit'];
                return $messages;
            }
        } else {
            $messages[]['error'] = $lang['lang']['error_exists'];
            return $messages;
        }
    } else {
        $messages[] = $error;
        return $messages;
    }
}

function deletEvent($db,$lang,$eventNumber) {
    if (!$db->exists($eventNumber)) {
        $messages[]['error'] = $lang['lang']['error_exists'];
        return $messages;
    } else {
        // Delete the item
        if (!$db->removebykey($eventNumber)) {
            $messages[]['error'] = $lang['lang']['error_del'];
            return $messages;
        }
    }
    $messages[]['succes'] = $lang['lang']['succes_del'];
    return $messages;
}

?>