<?php

/***************************************************************
* 
* access_control Plugin für moziloCMS.
* 
***************************************************************/
class access_control extends Plugin {

    /***************************************************************
    * 
    * Gibt den HTML-Code zurück, mit dem die Plugin-Variable ersetzt 
    * wird. Der String-Parameter $value ist Pflicht, kann aber leer 
    * sein.
    * 
    ***************************************************************/
    function getContent($value) 
    {
      GLOBAL $PLUGIN_DIR_REL;
      GLOBAL $CHARSET;
      GLOBAL $AC_CURRENT_USER;

      $current_url =(isset($_SERVER['HTTPS'])?'https':'http').'://' . $_SERVER['HTTP_HOST'] . str_replace('&amp;','&',$_SERVER['REQUEST_URI']);
      
      $separator_position = strpos($value, '|');
      if ($separator_position !== FALSE) 
      {
        $command = substr($value, 0, $separator_position);
        $value   = substr($value, $separator_position+1);
      }
      else 
      {
        $command = $value;
        $value = "";
      }


      switch ($command)
      {

        case "loginform":
            // {access_control|loginform}
            if ($AC_CURRENT_USER == "")
            {
              // Aktuell kein Benutzer angemeldet --> Login-Formular anzeigen
              $form = "";
              // Wenn beim Aufruf der index.php Anmeldedaten übergeben wurden ABER aktuell kein Benutzer angemeldet ist,
              // dann handelt es sich um einen Login-Fehler --> Fehlermeldung ausgeben
              if (($_SESSION['mozilo_login_status']=="ERROR")) $form .= "<font color=\"red\">Login fehlerhaft.</font><br>";
              // Als Ziel für's Formular soll nicht nur "index.php" angesprungen werden, weil sich vielleicht ein registrierter
              // Benutzer eine geschuetzte Seite gebookmarkt hat und er beim Aufruf des Bookmarks ohne Login eine andere (offene) Seite sieht.
              // Wenn er dann seine Login-Daten eingibt, dann soll er mit der gewünschten Seite belohnt werden und nicht nochmal das Bookmark
              // aufrufen müssen. Daher wird hier die aktuelle URI verwendet.
              $form .= "<form accept-charset=\"".$CHARSET."\" method=\"post\" action=\"".$current_url."\" class=\"searchform\"><fieldset id=\"searchfieldset\">"
              ."<input type=\"hidden\" name=\"ac_action\" value=\"login\" />"
              ."Benutzername:<br><input type=\"text\" name=\"ac_user\" value=\"\" class=\"searchtextfield\" /><br>"
              ."Passwort:<br><input type=\"password\" name=\"ac_password\" value=\"\" class=\"searchtextfield\" /><br>"
              ."<input type=\"submit\" value=\" Anmelden \">"
              ."</fieldset></form>";
            }
            else
            {
              // Aktuell Benutzer angemeldet --> Nur Logout-Button ausgeben
              //$ac_user_temp = $_SESSION['mozilo_user_logged_in'];
              //if ($ac_user_temp == "") $ac_user_temp = $_COOKIE['mozilo_user_logged_in']; // ab AccessControl Version 1.3
              $form = htmlentities($AC_CURRENT_USER)." ist angemeldet.<br><br>"
              ."<form accept-charset=\"".$CHARSET."\" method=\"post\" action=\"".$current_url."\" class=\"searchform\"><fieldset id=\"searchfieldset\">"
              ."<input type=\"hidden\" name=\"ac_action\" value=\"logout\" />"
              ."<input type=\"submit\" value=\" Abmelden \">"
              ."</fieldset></form>";
            }
         
            return $form;
            break;


        case "md5helper":
            // {access_control|loginform}
              $form = "";
              $form .= "<form accept-charset=\"".$CHARSET."\" method=\"post\" action=\"".$current_url."\">";
              $form .="<table border=\"0\"><tr><td>Passworteingabe:</td><td><input type=\"password\" name=\"ac_md5helper_password\" value=\"\" /></td></tr>";
              if ($_POST['ac_md5helper_password'] != "") $passwd = md5(utf8_decode($_POST['ac_md5helper_password'])); else $passwd = "";
                $form .= "<tr><td>Verschlüsseltes Passwort:</td><td><input type=\"text\" name=\"ac_md5helper_encryptedpassword\" value=\"".$passwd."\" size=\"40\" readonly=\"readonly\" /></td></tr>";
              $form .="<tr><td><input type=\"submit\" value=\" Verschlüsseln \"></td><td></td></tr>"
                    ."</table></form>";
            return $form;
            break;


        case "passwordchangeform":
            // {access_control|loginform}
            if ($AC_CURRENT_USER == "")
            {
              // Aktuell kein Benutzer angemeldet --> kein Formular fuer Passwortaenderung
              $form = "Es ist kein Benutzer angemeldet.";
            }
            else
            {
              $ac_users = $this->settings->get('ac_users');
              if (preg_match('/>('.preg_quote(utf8_encode($AC_CURRENT_USER),'/').')\|\w*?\+\|.*?</i', ">".$ac_users."<", $match) !=0 ) $user = $match[1]; else $user = "";
              $ac_old_password = md5(utf8_decode($_POST['ac_old_password']));
              $ac_new_password1 = md5(utf8_decode($_POST['ac_new_password1']));
              $ac_new_password2 = md5(utf8_decode($_POST['ac_new_password2']));
              //file_put_contents('debug.txt',"AC_CURRENT:".utf8_encode($AC_CURRENT_USER).' user:'.$user.' ac_old:'.$ac_old_password."\n".$ac_users);
              $continue_button = "<form accept-charset=\"".$CHARSET."\" method=\"post\" action=\"".$current_url."\">"
                                ."<input type=\"submit\" value=\" Weiter \">"
                                ."</form>";

              if ($user == "") 
                $form = "Das Passwort für den Benutzer <b>".htmlentities($AC_CURRENT_USER)."</b> kann nur durch den Administrator geändert werden.";
              else
              {// Der Benutzer darf das Passwort selbst setzen...             
                if ($_POST['ac_password_change'] == "true") 
                {// Selbstaufruf (Passwortdaten bereits eingegeben --> jetzt verarbeiten)
                   if ($ac_new_password1 == $ac_new_password2)
                   {// Passwort und Passwort-Wiederholung stimmen überein...
                     $ac_users = str_replace('>'.$user.'|'.$ac_old_password.'+|', '>'.$user.'|'.$ac_new_password1.'+|', $ac_users, $num_changes);
                     if ($num_changes == 1)
                     {
                       $this->settings->set('ac_users', $ac_users);
                       $form = "Das Passwort wurde gesetzt.<br><br>[continue]";
                       //file_put_contents('debug3.txt',$ac_users);
                     }
                     else
                     {
                       $form = "<font color=\"red\">Fehler: Das Setzen des Passworts war nicht erfolgreich - bitte geben Sie das korrekte alte Passwort ein.</font>"
                              ."<br><br>[continue]";
                     }
                   }
                   else 
                   {// Passwort und Wiederholung stimmen nicht überein
                     $form = "<font color=\"red\">Fehler: Die eingegebenen Passworte stimmen nicht überein.</font>"
                            ."<br><br>[continue]";
                   }
                }
                else
                {// Erstaufruf --> Formular für Passwörter ausgeben
                  $form ="<form accept-charset=\"".$CHARSET."\" method=\"post\" action=\"".$current_url."\">"
                        ."<input type=\"hidden\" name=\"ac_password_change\" value=\"true\" />"
                        ."<table border=\"0\"><tr>"
                        ."<tr><td colspan=\"2\">Benutzer <b>".htmlentities($AC_CURRENT_USER)."</b> ist angemeldet.</td></tr>"
                        ."<td>altes Passwort:</td><td><input type=\"password\" name=\"ac_old_password\" value=\"\" /></td>"
                        ."</tr><tr>"
                        ."<td>neues Passwort:</td><td><input type=\"password\" name=\"ac_new_password1\" value=\"\" /></td>"
                        ."</tr><tr>"
                        ."<td>neues Passwort (Wiederholung):</td><td><input type=\"password\" name=\"ac_new_password2\" value=\"\" /></td>"
                        ."</tr>"
                        ."<tr><td><input type=\"submit\" value=\" Passwort setzen \"></td><td></td></tr>"
                        ."</table></form>";
                }
              }
            }
            $form = str_replace('[continue]', $continue_button, $form);
            return $form;
            break;


        case "contentfilter":
            //                              |--> cmdstring
            // {access_control|contentfilter|no_login;Inhalt...}
            // {access_control|contentfilter|whitelist=user1,user2;Inhalt...}
            $splitpos = strpos ($value, ";");
            $cmdstring= substr ($value, 0, $splitpos);
            $content  = substr ($value, $splitpos+1);
            
            $command = substr ($cmdstring, 0, strpos($cmdstring, "=")); 
            $userstr = substr ($cmdstring, strpos($cmdstring, "=")+1);
            //$users   = explode (",", strtolower ($userstr));
            $userstr = ",".trim(strtolower ($userstr)).",";
            
            //$current_user = $_SESSION['mozilo_user_logged_in'];
            //if ($current_user == "") $current_user = $_COOKIE['mozilo_user_logged_in'];
            //$current_user = strtolower ($current_user);

            switch ($cmdstring)
            {
              case "no_login":
                if ($AC_CURRENT_USER == "") return $content; else return "";
                break;
                
              case "any_login":
                if ($AC_CURRENT_USER != "") return $content; else return "";
                break;
            }
            
            if ($AC_CURRENT_USER != "")
            {
              if (strpos($userstr, ",".strtolower($AC_CURRENT_USER).",")!== FALSE) $user_match = 1; else $user_match = 0;
              switch ($command)
              {
                case "whitelist":
                  if ($user_match == 1) return $content; else return "";
                  break;
      
                case "blacklist":
                  if ($user_match == 0) return $content; else return "";
                  break;
              }
            }
            return "";
            break;


        case "ac_log":
            $temp = "";
            $file = $PLUGIN_DIR_REL."access_control/ac_log.txt";
            if (is_file($file)) $temp = htmlentities(file_get_contents($file));
            $temp = "<pre>".$temp."</pre>";
            $temp = str_replace ("\r\n", "<br />", $temp);
            $temp = str_replace ("\n", "<br />", $temp);
            return $temp; 
            break;

            
        case "current_user":
            return $AC_CURRENT_USER;
            break;

      } // switch ($command)

    } // function getContent
    
    
    
    /***************************************************************
    * 
    * Gibt die Konfigurationsoptionen als Array zurück.
    * Ist keine Konfiguration nötig, ist dieses Array leer.
    * 
    ***************************************************************/
    function getConfig() {
        global $ADMIN_CONF;
        $language = $ADMIN_CONF->get("language");

        // Rückgabe-Array initialisieren
        // Das muß auf jeden Fall geschehen!
        $config = array();
        
        // nur eine Sprache ---------------------------------

        $config['ac_users'] = array(
            "type" => "textarea",                       // Pflicht:  Eingabetyp 
            "cols" => "95",                             // Pflicht:  Spaltenanzahl 
            "rows" => "12",                              // Pflicht:  Zeilenanzahl
            "description" => "Benutzerliste",     // Pflicht:  Beschreibung
            "regex" => "/^.+$/"           ,             // optional: Erlaubte Werte als regulärer Ausdruck (hier: wenigstens ein Zeichen; wird beim Speichern der Einstellungen überprüft)
            "regex_error" => "Die Eingabe darf nicht leer sein." // optional: Fehlermeldung für die RegEx-Überprüfung
        );

        $config['ac_accesslist'] = array(
            "type" => "textarea",                       // Pflicht:  Eingabetyp 
            "cols" => "95",                             // Pflicht:  Spaltenanzahl 
            "rows" => "15",                              // Pflicht:  Zeilenanzahl
            "description" => "Zugriffsliste",     // Pflicht:  Beschreibung
            "regex" => "/^.+$/"           ,             // optional: Erlaubte Werte als regulärer Ausdruck (hier: wenigstens ein Zeichen; wird beim Speichern der Einstellungen überprüft)
            "regex_error" => "Die Eingabe darf nicht leer sein." // optional: Fehlermeldung für die RegEx-Überprüfung
        );

        $config['login_log_enable'] = array(
            "type" => "checkbox",                       // Pflicht:  Eingabetyp 
            "description" => "Logins protokollieren"            // Pflicht:  Beschreibung
        );

        $config['login_log_length']  = array(
            "type" => "text",                           // Pflicht:  Eingabetyp
            "description" => "Max. Einträge im Protokoll",     // Pflicht:  Beschreibung
            "maxlength" => "4",                       // optional: maximale Länge
            "size" => "10"                            // optional: dargestellte Zeichen
        );

        $config['login_log_email_enable'] = array(
            "type" => "checkbox",                       // Pflicht:  Eingabetyp 
            "description" => "Email bei Login senden"            // Pflicht:  Beschreibung
        );

        $config['login_log_email_subject']  = array(
            "type" => "text",                           // Pflicht:  Eingabetyp
            "description" => "Email-Betreff",     // Pflicht:  Beschreibung
            "maxlength" => "50",                       // optional: maximale Länge
            "size" => "50"                             // optional: dargestellte Zeichen
        );

        $config['login_log_email_receivers'] = array(
            "type" => "textarea",                       // Pflicht:  Eingabetyp 
            "cols" => "50",                             // Pflicht:  Spaltenanzahl 
            "rows" => "3",                              // Pflicht:  Zeilenanzahl
            "description" => "Empfänger-Emailadressen (1 Adresse pro Zeile, ohne Trennzeichen)"     // Pflicht:  Beschreibung
        );

        $config['login_log_nolog_userlist']  = array(
            "type" => "text",                           // Pflicht:  Eingabetyp
            "description" => "Benutzer, deren Logins nicht geloggt werden sollen (user1,user2,...)",     // Pflicht:  Beschreibung
            "maxlength" => "500",                       // optional: maximale Länge
            "size" => "95"                             // optional: dargestellte Zeichen
        );

        $config['login_log_email_sender']  = array(
            "type" => "text",                           // Pflicht:  Eingabetyp
            "description" => "Absender-Emailadresse",     // Pflicht:  Beschreibung
            "maxlength" => "50",                       // optional: maximale Länge
            "size" => "50"                             // optional: dargestellte Zeichen
        );

        $config['export_userlist'] = array(
            "type" => "checkbox",                       // Pflicht:  Eingabetyp 
            "description" => "Gültige Benutzer für andere Plugins in Datei speichern"            // Pflicht:  Beschreibung
        );

        // Nicht vergessen: Das gesamte Array zurückgeben
        return $config;
        
    } // function getConfig    
    

    
    /***************************************************************
    * 
    * Gibt die Plugin-Infos als Array zurück - in dieser 
    * Reihenfolge:
    *   - Name und Version des Plugins
    *   - für moziloCMS-Version
    *   - Kurzbeschreibung
    *   - Name des Autors
    *   - Download-URL
    *   - Platzhalter für die Selectbox
    * 
    ***************************************************************/
    function getInfo() {
        global $ADMIN_CONF;
        
        /********************/   $AC_VERSION = "2.0.1";  /************************/
        
        $debug = "";
        // Fuer PHP4...
        if (!function_exists('file_put_contents')) {   
          function file_put_contents($filename, $data) {       
            if (($h = @fopen($filename, 'w')) === false) return false;       
            if (($bytes = @fwrite($h, $data)) === false) return false;       
            fclose($h);       
            return $bytes; 
          }
        }

        function ac_check_patch($matches_desired)
        {
          GLOBAL $BASE_DIR;
          $retval = "";
          $temp = file_get_contents($BASE_DIR."/index.php");
          if (preg_match('/access_control version (.*?)\*/',$temp,$matches)> 0 ) $retval = $matches[1];
          $patched_line_count = preg_match_all('/\/\*AC\*\//', $temp, $matches);
          if (($patched_line_count != $matches_desired) && ($patched_line_count > 0)) $retval .= "   ** PATCH FEHLER **";  
          return $retval;
        }

        function ac_apply_patch($status, $version)
        {
          GLOBAL $BASE_DIR;
          $temp = file ($BASE_DIR."/index.php");
          $temp2 = array();
          
          foreach ($temp as $line)
          {
            if ($status == 1)
            {
              $temp2[] = rtrim($line);
              if (strpos($line, "session_start();")!==FALSE)
              {
                $temp2[] = "/*AC*/";
                $temp2[] = "/*AC*/ /*index.php patched by access_control version ".$version."*/";
                $temp2[] = "/*AC*/";
              }
              if (preg_match('/ *\$HTML *= *""/', $line)>0)
              {
                $temp2[] = "/*AC*/";
                $temp2[] = "/*AC*/ require_once (\$PLUGIN_DIR_REL.\"access_control/ac_logincheck.php\");";
                $temp2[] = "/*AC*/";
              }
              if (strpos($line, "return \$files;")!== FALSE)
              {
                $temp3 = array_pop ($temp2);
                $temp2[] = "/*AC*/";
                $temp2[] = "/*AC*/ global \$PLUGIN_DIR_REL;";
                $temp2[] = "/*AC*/ require (\$PLUGIN_DIR_REL.\"access_control/ac_directoryfilter.php\");";
                $temp2[] = "/*AC*/";
                $temp2[] = $temp3;
              }
            } // if
            elseif (strpos($line, "/*AC*/")===FALSE) $temp2[] = rtrim($line);
          } // foreach ($temp as $line)
          file_put_contents ($BASE_DIR."/index.php", implode("\n", $temp2));
        }
  
        $language = $ADMIN_CONF->get("language");
        $patched_lines_desired = 10;
        $patch_status = "<span style=\"background-color:#FFA0A0; font-weight:bold;\">| nicht gepached |</span>";
        $version = ac_check_patch($patched_lines_desired);
        if (($this->settings->get('active')=='true')  && ($version == "")) ac_apply_patch(1, $AC_VERSION);
        if (($this->settings->get('active')=='false') && ($version != "")) ac_apply_patch(0, "");
        $version = ac_check_patch($patched_lines_desired);
        
        //$debug = $this->settings->get('active').",".$version;
        if ($version != "") $patch_status = "<span style=\"background-color: #A0FFA0; font-weight:bold;\">| Patch Version ".$version." |</span>";
        # nur eine Sprache ---------------------------------
        $info = array(
            // Plugin-Name + Version
            "<b>access_control</b> ".$AC_VERSION,
            // moziloCMS-Version
            "1.12.beta3 (vorr. auch Folgeversionen)",
            // Kurzbeschreibung nur <span> und <br /> sind erlaubt
            ''.$debug.'Plugin zur Seiten-Zugangsbeschränkung mit benutzerabängigem Menü- und Seitenumfang
             <br /><br />
             Nach Aktivierung des Plugins werden alle Kategorien und Seiten mit \' (Hochkomma) am Namensende nur ausgegeben, wenn 
             der aktuell angemeldete Benutzer die Berechtigung dafür hat. 
             Das \' ist für den angemeldeten Benutzer gleichzeitig eine Info, welche Seiten er nur aufgrund seines Logins sehen kann. 
             <br>Ein Schutz von Kategorien oder Inhaltsseiten, die lediglich einen Menü-Direktlink enthalten, ist nicht möglich. Hierfür gibt es einen Tipp in der Dokumentation (<span style="font-weight:bold;">doku.html</span> im Plugin-Verzeichnis). Für direktverlinkte Inhaltsseiten innerhalb einer geschützten Kategorie gibt es keine Einschränkungen.
             <br><span style="color:red;">Nach Änderung des Aktivierungs-Zustands entweder einfach [fett|zwei]mal "Einstellungen speichern" betätigen oder nach dem Speichern die Seite im Browser re-loaden.<br>
             ACHTUNG: Nach Deaktivierung des Plugins sind alle geschützten Seiten (mit \' am Ende) sichtbar!</span>
             <br /><br />
             Hinweis: Es wird dringend empfohlen, für das access_control-Verzeichnis einen Verzeichnisschutz mittels .htaccess einzurichten, um Benutzer- und Passwortdaten vor unbefugtem Zugriff zu schützen. 
             <br /><br />
             [fett|Patch-Status der index.php: ]'.$patch_status.'<br>
             Hinweis: Die Haupt-index.php wird beim Aktivieren des Plugins automatisch um ein paar Zeilen erweitert, bei der Deaktiverung werden diese Zeilen wieder gelöscht.
             Hier muss eine Patch-Version zurückgemeldet werden, damit das Plugin funktionieren kann.
             Weicht die Patch-Version von der Plugin-Version ab, so kann dies mittels Deaktivierung und anschliessender Reaktivierung des Plugins behoben werden.
             <br>[fett|Bitte auch bei Fehlersuche an anderer Stelle den Patch mit in Betracht ziehen (die Beeinflussung ist unwahrscheinlich aber möglich)!]
             <br /><br />
             [fett|Allgemeine Beschreibung und Einrichtung:] 
             <br>Bitte unbedingt die Datei [fett|doku.html] im Plugin-Verzeichnis beachten! <br>
             <br /><br />
             [fett|Befehlssyntax:]
             <br /><br>  
             [unter|In der Template-Datei ODER einer beliebigen Inhaltsseite:]<br />
             <br>
             [mono|{access_control|loginform}] <br>Ausgabe des Login-Formulars (im Template z.B. analog zum Suchformular) 
             <br /> <br>
             [unter|In den Inhaltsseiten:]<br>
             <br> 
             [mono|{access_control|contentfilter|no_login;...}]<br>Ausgabe ..., falls kein Benutzer angemeldet ist<br>
             [mono|{access_control|contentfilter|any_login;...]} <br>Ausgabe ..., falls irgendein Benutzer angemeldet ist<br>
             [mono|{access_control|contentfilter|whitelist=user1,user2;...}] <br>Ausgabe ..., falls user1 oder user2 angem. ist<br>
             [mono|{access_control|contentfilter|blacklist=user1,user2;...}] <br>Ausgabe ..., wenn user1 & user2 nicht angem. sind<br>
             [mono|{access_control|ac_log}] <br>Ausgabe des Login-Protokolls in eine Inhaltsseite<br>
             [mono|{access_control|current_user}] <br>Ausgabe des aktuell angemeldeten Benutzers; dieser Befehl kann im Argument eines anderen Plugins enthalten sein, um dem anderen Plugin den aktuell angemeldeten Benutzer mitzuteilen und so die hier implementierte Login-Logik für andere Plugins zu nutzen. Eine weitere "API" ist in doku.html erklärt.<br>
             [mono|{access_control|passwordchangeform}] <br>Ausgabe eines Formulars zur Passwortänderung für den aktuell angemeldeten Benutzer. Falls dieser nicht berechtigt ist, erfolgt eine entsprechende Ausgabe.<br>
             [mono|{access_control|md5helper}] <br>Ausgabe eines Hilfsformulars zur MD5-Verschlüsselung von Passwörtern<br>
             <br><br>
             [fett|Beschreibung der wesentlichen Plugin-Einstellungen:]
             <br /><br>
             [unter|Benutzerliste:]<br>
             [fett|Format der Einträge] (je Zeile): [mono|Benutzername|MD5-Passwort|Timeout]<br>
             Ein # als erstes Zeichen markiert eine Kommentarzeile.<br>
             [fett|MD5-Passwort:] Wird an das Passwort ein [fett|+] (Pluszeichen) angehängt, so darf der Benutzer sein Passwort selbst ändern. Die MD5-Verschlüsselung kann z.B. auf http://www.php-space.info/php/space/md5-generatoren.php oder mit dem mittels {access_control|md5helper} erzeugten Formular durchgeführt werden.
             Als Startpasswort für Benutzer, die selbst ändern dürfen, kann z.B. [mono|19ad89bc3e3c9d7ef68b89523eff1987] (=install) verwendet werden.<br>
             [fett|Timeout] (in Sekunden): -1=standard PHP-Session-Timeout des Webservers, sonst werden automatisch zusaetzlich Cookies verwendet<br>
             <br>
             [unter|Zugriffsliste:]<br>
             [fett|Format der Einträge] (je Zeile): [mono|Kategoriename\'|Seitenname\'|user1,user2,user3</span><br>
             Ein # als erstes Zeichen markiert eine Kommentarzeile.<br>
             Wird kein Seitenname angegeben, so wird die komplette Kategorie gesperrt bzw. freigegeben.<br> 
             [fett|Kategoriename] und [fett|Seitenname] werden so angegeben, wie sie auch im Seitenmenü erscheinen (ohne "10_" o.Ä., mit "äöü" und inkl. \' ).<br>
             Wird der [fett|Benutzer] [mono|any_login] angegeben, so muss zur Betrachtung der Seite lediglich irgendein gültiger Benutzer angemeldet sein.<br> 
             Die Reihenfolge der Einträge ist beliebig.
            <br><br>', 
            // Name des Autors
            "mhsob",
            // Download-URL
            "http://cms.mozilo.de/plugins/details.php?image_id=37",
            // Platzhalter für die Selectbox in der Editieransicht 
            // - ist das Array leer, erscheint das Plugin nicht in der Selectbox
            array(
                '{access_control|loginform}' => 'Ausgabe des Login-Formulars (Verw. im HTML-Template) analog zum Suchformular',
                '{access_control|contentfilter|no_login;...}' => 'Ausgabe von ..., falls kein Benutzer angemeldet ist',
                '{access_control|contentfilter|any_login;...}' => 'Ausgabe von ..., falls irgendein Benutzer angemeldet ist',
                '{access_control|contentfilter|whitelist=user1,user2;...}' => 'Ausgabe von ..., falls user1 oder user2 angemeldet ist',
                '{access_control|contentfilter|blacklist=user1,user2;...}' => 'Ausgabe von ..., falls weder user1, noch user2 angemeldet ist',
                '{access_control|ac_log}' => 'Ausgabe des Login-Protokolls in eine Inhaltsseite',
                '{access_control|current_user}' => 'Ausgabe des aktuell angemeldeten Benutzers',
                '{access_control|passwordchangeform}' => 'Ausgabe eines Formulars zur Passwortänderung'
            )
        );
        // Rückgabe der Infos.
        // Auch hier könnte man die Inhalte natürlich von der aktuell im Admin eingestellten 
        // Sprache abhängig machen - siehe getConfig().
        $underline = '<span style="text-decoration:underline;">';
        $bold      = '<span style="font-weight:bold;">';
        $span_end  = '</span>';
        $monospace = '<span style="font-family:monospace;font-weight:bold;">';
        $info[2] = str_replace ("[unter|", $underline, $info[2]);
        $info[2] = str_replace ("[fett|", $bold, $info[2]);
        $info[2] = str_replace ("[mono|", $monospace, $info[2]);
        $info[2] = str_replace ("]", $span_end, $info[2]);
        return $info;
        
    } // function getInfo

} // class access_control

?>